package de.wlami.cxf.forwardedforexample;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.servlet.http.HttpServletRequest;

import org.apache.cxf.message.Message;
import org.apache.cxf.phase.PhaseInterceptorChain;
import org.apache.cxf.transport.http.AbstractHTTPDestination;

@WebService
public class Service {

	@WebMethod(action = "sayHello")
	public String sayHello(@WebParam(name = "name") String name) {
		String address = getClientAddress();
		return "Hello " + name + ". You came from " + address + "!" ;
	}

	private String getClientAddress() {
		Message message = PhaseInterceptorChain.getCurrentMessage();
		HttpServletRequest request = (HttpServletRequest)message.get(AbstractHTTPDestination.HTTP_REQUEST);
		return request.getRemoteAddr();
	}

}
